/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/*
 * This file is part of the libe-book project.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#ifndef IMPLZSSSTREAMTEST_H_INCLUDED
#define IMPLZSSSTREAMTEST_H_INCLUDED

#include <string>

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

namespace test
{

class IMPLZSSStreamTest : public CPPUNIT_NS::TestFixture
{
public:
  virtual void setUp();
  virtual void tearDown();

private:
  CPPUNIT_TEST_SUITE(IMPLZSSStreamTest);
  CPPUNIT_TEST(testRead);
  CPPUNIT_TEST(testSeek);
  CPPUNIT_TEST_SUITE_END();

private:
  void testRead();
  void testSeek();

  void testReadAll(const std::string &text, librevenge::RVNGInputStream *stream);
};

}

#endif // IMPLZSSSTREAMTEST_H_INCLUDED

/* vim:set shiftwidth=2 softtabstop=2 expandtab: */
